#include "caf/config.hpp"

CAF_PUSH_DEPRECATED_WARNING

#include "caf/flow/backpressure_overflow_strategy.hpp"

#include <string>
#include <string_view>

namespace caf::flow {

std::string to_string(backpressure_overflow_strategy x) {
  switch (x) {
    default:
      return "???";
    case backpressure_overflow_strategy::drop_newest:
      return "drop_newest";
    case backpressure_overflow_strategy::drop_oldest:
      return "drop_oldest";
    case backpressure_overflow_strategy::fail:
      return "fail";
  }
}

bool from_string(std::string_view in, backpressure_overflow_strategy& out) {
  if (in == "drop_newest"
      || in == "caf::flow::backpressure_overflow_strategy::drop_newest") {
    out = backpressure_overflow_strategy::drop_newest;
    return true;
  }
  if (in == "drop_oldest"
      || in == "caf::flow::backpressure_overflow_strategy::drop_oldest") {
    out = backpressure_overflow_strategy::drop_oldest;
    return true;
  }
  if (in == "fail"
      || in == "caf::flow::backpressure_overflow_strategy::fail") {
    out = backpressure_overflow_strategy::fail;
    return true;
  }
  return false;
}

bool from_integer(std::underlying_type_t<backpressure_overflow_strategy> in,
                  backpressure_overflow_strategy& out) {
  auto result = static_cast<backpressure_overflow_strategy>(in);
  switch (result) {
    default:
      return false;
    case backpressure_overflow_strategy::drop_newest:
    case backpressure_overflow_strategy::drop_oldest:
    case backpressure_overflow_strategy::fail:
      out = result;
      return true;
  }
}

} // namespace caf::flow

